#include <assert.h>
#include <stdlib.h>
#include "fixed_stack.h"

struct fixed_stack *fixed_stack_init() {
    struct fixed_stack *s = malloc(sizeof(struct fixed_stack));
    s->top = -1;
    return s;
}

void fixed_stack_destroy(struct fixed_stack *s) {
    free(s);
}

int fixed_stack_pop(struct fixed_stack *s) {
    assert(s->top >= 0);
    int r = s->values[s->top];
    s->top -= 1;
    return r;
}

void fixed_stack_push(struct fixed_stack *s, int value) {
    assert(s->top < SIZE - 1);
    s->top += 1;
    s->values[s->top] = value;
}
