#ifndef STACK_H
#define STACK_H

struct stack_methods {
    void (*push)(void*, int);
    int (*pop)(void*);
    void (*destroy)(void*);
};

struct stack {
    void* obj;
    struct stack_methods* methods;
};

struct stack new_fixed_stack();

struct stack new_dynamic_stack();

void destroy(struct stack* s);

int pop(struct stack* s);

void push(struct stack* s, int value);

#endif /* ifndef STACK_H */
