#include <assert.h>
#include <stdlib.h>

#define SIZE 100

struct stack {
    int top;
    int values[SIZE];
};

struct stack *init() {
    struct stack *s = malloc(sizeof(struct stack));
    s->top = -1;
    return s;
}

void destroy(struct stack *s) {
    free(s);
}

int pop(struct stack *s) {
    assert(s->top >= 0);
    int r = s->values[s->top];
    s->top -= 1;
    return r;
}

void push(struct stack *s, int value) {
    assert(s->top < SIZE - 1);
    s->top += 1;
    s->values[s->top] = value;
}
