#include "dynamic_stack.h"
#include <vector>

extern "C" {
    struct dynamic_stack {
        std::vector<int> vec;
    };

    dynamic_stack *dynamic_stack_init() {
        return new dynamic_stack();
    }

    void dynamic_stack_destroy(dynamic_stack *s) {
        delete s;
    }

    int dynamic_stack_pop(struct dynamic_stack *s) {
        int top = s->vec.back();
        s->vec.pop_back();
        return top;
    }

    void dynamic_stack_push(struct dynamic_stack *s, int value) {
        s->vec.push_back(value);
    }
}
