#ifndef DYNAMIC_STACK_H
#define DYNAMIC_STACK_H

#ifdef __cplusplus
extern "C" {
#endif

struct dynamic_stack *dynamic_stack_init();

void dynamic_stack_destroy(struct dynamic_stack *s);

int dynamic_stack_pop(struct dynamic_stack *s);

void dynamic_stack_push(struct dynamic_stack *s, int value);

#ifdef __cplusplus
}
#endif

#endif /* ifndef DYNAMIC_STACK_H */
