#include <vector>

extern "C" {
    struct stack {
        std::vector<int> vec;
    };

    stack *init() {
        return new stack();
    }

    void destroy(stack *s) {
        delete s;
    }

    int pop(struct stack *s) {
        int top = s->vec.back();
        s->vec.pop_back();
        return top;
    }

    void push(struct stack *s, int value) {
        s->vec.push_back(value);
    }
}
